//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: ethermint/evm/v1/tx.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Msg defines the evm Msg service.
///
/// Usage: instantiate `Ethermint_Evm_V1_MsgClient`, then call methods of this protocol to make API calls.
internal protocol Ethermint_Evm_V1_MsgClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Ethermint_Evm_V1_MsgClientInterceptorFactoryProtocol? { get }

  func ethereumTx(
    _ request: Ethermint_Evm_V1_MsgEthereumTx,
    callOptions: CallOptions?
  ) -> UnaryCall<Ethermint_Evm_V1_MsgEthereumTx, Ethermint_Evm_V1_MsgEthereumTxResponse>
}

extension Ethermint_Evm_V1_MsgClientProtocol {
  internal var serviceName: String {
    return "ethermint.evm.v1.Msg"
  }

  /// EthereumTx defines a method submitting Ethereum transactions.
  ///
  /// - Parameters:
  ///   - request: Request to send to EthereumTx.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func ethereumTx(
    _ request: Ethermint_Evm_V1_MsgEthereumTx,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Ethermint_Evm_V1_MsgEthereumTx, Ethermint_Evm_V1_MsgEthereumTxResponse> {
    return self.makeUnaryCall(
      path: "/ethermint.evm.v1.Msg/EthereumTx",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeEthereumTxInterceptors() ?? []
    )
  }
}

internal protocol Ethermint_Evm_V1_MsgClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'ethereumTx'.
  func makeEthereumTxInterceptors() -> [ClientInterceptor<Ethermint_Evm_V1_MsgEthereumTx, Ethermint_Evm_V1_MsgEthereumTxResponse>]
}

internal final class Ethermint_Evm_V1_MsgClient: Ethermint_Evm_V1_MsgClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Ethermint_Evm_V1_MsgClientInterceptorFactoryProtocol?

  /// Creates a client for the ethermint.evm.v1.Msg service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Ethermint_Evm_V1_MsgClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Msg defines the evm Msg service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Ethermint_Evm_V1_MsgProvider: CallHandlerProvider {
  var interceptors: Ethermint_Evm_V1_MsgServerInterceptorFactoryProtocol? { get }

  /// EthereumTx defines a method submitting Ethereum transactions.
  func ethereumTx(request: Ethermint_Evm_V1_MsgEthereumTx, context: StatusOnlyCallContext) -> EventLoopFuture<Ethermint_Evm_V1_MsgEthereumTxResponse>
}

extension Ethermint_Evm_V1_MsgProvider {
  internal var serviceName: Substring { return "ethermint.evm.v1.Msg" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "EthereumTx":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Ethermint_Evm_V1_MsgEthereumTx>(),
        responseSerializer: ProtobufSerializer<Ethermint_Evm_V1_MsgEthereumTxResponse>(),
        interceptors: self.interceptors?.makeEthereumTxInterceptors() ?? [],
        userFunction: self.ethereumTx(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Ethermint_Evm_V1_MsgServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'ethereumTx'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeEthereumTxInterceptors() -> [ServerInterceptor<Ethermint_Evm_V1_MsgEthereumTx, Ethermint_Evm_V1_MsgEthereumTxResponse>]
}
